The exciting FP-LAPW Code
=========================

Release: exciting neon.  
Copyright (C) 2002-2023 The exciting team.

Description
-----------

exciting is an all-electron full-potential computer package for
first-principles calculations, based on (linearized) augmented planewave
\+ local orbital \[(L)APW+lo\] methods. This family of basis sets is
known as the most precise numerical scheme to solve the Kohn-Sham
equations of density-functional theory (DFT), reaching up to
micro-Hartree precision \[[1](#citing-exciting-%20in-your-work)\].

exciting features include:

+ Ground state DFT with LDA, GGA and hybrid functionals \[[1,
    2](#citing-exciting-in-your-work)\].

+ Time-dependent DFT, both in the frequency domain (with the linear
    response formalism) \[[3](#citing-exciting-in-your-work)\] and
    and in the real-time domain \[[4](#citing-exciting-in-your-work)\].

+ GW in the G0W0 approximation \[[5](#citing-exciting-in-your-work)\].

+ The Bethe-Salpeter equation for both valence excitations
    \[[4](#citing-exciting-in-your-work)\] and core excitations
    \[[6](#citing-exciting-in-your-work)\].

Documentation for developers
----------------------------

The documentation for developers can be found in the [exciting gitlab wiki](https://git.physik.hu-berlin.de/sol/exciting/-/wikis/home).

Obtaining the Source
--------------------

exciting neon can be downloaded from the [exciting
webpage](http://exciting-code.org).

exciting is updated regularly with new features and bug fixes. This
release may be used for limited production but please check the
consistency of the results carefully. Patched minor releases are also
available on exciting's [Github
page](https://github.com/exciting/exciting).

Information on compiling and testing exciting can be found in the
INSTALL file, located within the root directory.

Citing exciting in Your Work
----------------------------

If you use exciting in your work, please cite the following paper:

\[1\]: [exciting --- a full-potential all-electron package implementing
density-functional theory and many-body perturbation theory. 2014
J.Phys.: Condens. Matter 26363202.](https://doi.org/10.1088/0953-8984/26/36/363202)

Additionally, if you use specific features, please cite the
corresponding papers where applicable:

\[2\]: [Probing the LDA-1/2 method as a starting point for G0W0
calculations. Phys. Rev. B **94**, 235141
(2016).](https://doi.org/10.1103/PhysRevB.94.235141)

\[3\]: [Time-dependent density functional theory versus Bethe--Salpeter
equation: an all-electron study. ***Phys. Chem. Chem. Phys.***, 2009,
**11**, 4451-4457.](https://doi.org/10.1039/%20B903676H)

\[4\]: [All-electron full-potential implementation of real-time TDDFT in
exciting. Electron. Struct. **3**, 
037001 (2021).](https://doi.org/10.1088/2516-1075/ac0c26)

\[5\]: [Accurate all-electron G0W0 quasiparticle energies employing the
full-potential augmented plane-wave method. Phys. Rev. B **94**, 035118
(2016).](https://doi.org/10.1103/PhysRevB.%2094.035118)

\[6\]: [Addressing electron-hole correlation in core excitations of
solids: An all-electron many- body approach from first principles. Phys.
Rev. B **95**, 155121
(2017).](https://doi.org/%2010.1103/PhysRevB.95.155121)
