! Copyright (C) 2002-2020 J. K. Dewhurst, S. Sharma, C. Meisenbichler and
! C. Ambrosch-Draxl.
! This file is distributed under the terms of the GNU General Public License.
! See the file COPYING for license details.

!> Miscellaneous variables 
Module mod_misc
  Use modinput
  implicit none
  
  !> Code version
  character(40) :: versionname = 'NEON'

  !> Build date of current version
  integer :: version(3)

  !> git hash value of current build at HEAD
  character(40) :: githash

  !> Compiler used to build current version
  character(256) :: compiler_version

  !> Default file extension
  Data filext / '.OUT' /
  !> filename extension for files generated by gndstate
  Character (256) :: filext
  
  !> reference version for LDA+U
  integer, parameter :: refversion_ldapu(3) = (/ 0, 9, 131 /)
  !> reference version for new exciting
  integer, parameter :: refversion_new(3) = (/ 0, 9, 224 /)
  !> reference version (date-based) for githash in STATE.OUT file
  integer, parameter :: refversion_gitstate(3) = (/ 10, 4, 14 /)
  
  !> maximum number of tasks
  Integer, Parameter :: maxtasks = 40
  !> number of tasks
  Integer :: ntasks
  !> task array
  Integer :: tasks (maxtasks)
  !> current task
  Integer :: task
  
  !> tstop is .true. if STOP file exists
  Logical :: tstop
  !> tlast is .true. if self-consistent loop is on the last iteration
  Logical :: tlast
  
  !> Scratch space path
  Character (256) :: scrpath  
  !> Maximum number of note lines
  Integer, Parameter :: maxnlns = 20
  !> Number of note lines
  Integer :: notelns
  !> Notes to include in INFO.OUT
  Character (80) :: notes (maxnlns)

End Module mod_misc

